% Created 2023-12-12 Tue 20:01
% Intended LaTeX compiler: pdflatex
\documentclass[presentation]{beamer}
\usepackage[utf8]{inputenc}
\usepackage[T1]{fontenc}
\usepackage{graphicx}
\usepackage{longtable}
\usepackage{wrapfig}
\usepackage{rotating}
\usepackage[normalem]{ulem}
\usepackage{amsmath}
\usepackage{amssymb}
\usepackage{capt-of}
\usepackage{hyperref}
\usetheme{default}
\author{Philip Hands}
\date{\today}
\title{How to write new tests for openQA}
\hypersetup{
 pdfauthor={Philip Hands},
 pdftitle={How to write new tests for openQA},
 pdfkeywords={},
 pdfsubject={},
 pdfcreator={Emacs 28.2 (Org mode 9.7)}, 
 pdflang={English}}
\begin{document}

\maketitle
\begin{frame}[label={sec:orgc131114}]{What is openQA?}
A thing for running tests on whole systems, by \emph{looking} at the screen, and reacting to what it \emph{sees} in various ways.

\url{https://debconf21.debconf.org/talks/31-openqadebiannet-automated-testing-of-debian-installer-and-beyond}
\end{frame}
\begin{frame}[label={sec:orgd65810a},fragile]{Getting started}
 \begin{itemize}
\item Install \alert{openQA} locally
\begin{itemize}
\item Directly on your system:
\begin{verbatim}
apt install openqa openqa-worker
\end{verbatim}

(currently needs things from \alert{sid})

\item in a VM:

Roland's blog: \url{https://rclobus.nl/blog/?p=267}
\end{itemize}
\end{itemize}
\end{frame}
\begin{frame}[label={sec:orgf723f12}]{Shared test area}
\begin{itemize}
\item writable for you and openQA's \uline{geekotest} user
\item openQA is unwilling to follow sym-links
\item I use a bind-mount, and keep the tests under home
\item I create a \uline{geekotest} group and give it write access.
\end{itemize}

This is a work in progress -- I'm interested to know how others go about it.
\end{frame}
\begin{frame}[label={sec:org1268b08},fragile]{Writing a test}
 \begin{itemize}
\item clone the test repo (after forking it on salsa)
\href{https://salsa.debian.org/qa/openqa/openqa-tests-debian/}{salsa.debian.org/qa/openqa/openqa-tests-debian}
\item find a similar test.  e.g.:
\begin{verbatim}
tests/desktop_printing.pm
\end{verbatim}
\end{itemize}
\begin{block}{Our new test:}
\begin{verbatim}
use base "installedtest";
use strict;
use testapi;
use utils;

sub run {
    my $self = shift;

    # throw a delay in, to ensure that we've a settled state in the desktop
    # before switching away from it, in the hope that lets us get back here
    wait_still_screen(stilltime=>5, similarity_level=>45);

    # Prepare the environment:
    #
    # Become root
    $self->root_console(tty=>3);
    console_loadkeys_us;

    # make sure emacs is installed
    assert_script_run "apt install -y emacs", 180;
    # Leave the root terminal and switch back to desktop.
    desktop_vt();

    # Run emacs via Alt-F2
    wait_screen_change { send_key "alt-f2"; };
    wait_still_screen(stilltime=>5, similarity_level=>45);

    type_very_safely "emacs\n";
    wait_still_screen(stilltime=>5, similarity_level=>44);
    if (check_screen "console_instead_of_GUI", 1) {
        die "failed to switch back to GUI";
    }

    assert_screen "emacs_splashscreen";
    send_key "alt-x";
    type_safely "hanoi\n";
    assert_screen "emacs_hanoi_solved";
}


sub test_flags {
    return { fatal => 1 };
}

1;
\end{verbatim}
\end{block}
\begin{block}{standard intro}
\begin{verbatim}
use base "installedtest";
use strict;
use testapi;
use utils;

sub run {
    my $self = shift;

    # throw a delay in, to ensure that we've a settled state in the desktop
    # before switching away from it, in the hope that lets us get back here
    wait_still_screen(stilltime=>5, similarity_level=>45);
\end{verbatim}
\end{block}
\begin{block}{prepare test environment (install emacs)}
\begin{verbatim}
    # Prepare the environment:
    #
    # Become root
    $self->root_console(tty=>3);
    console_loadkeys_us;

    # make sure emacs is installed
    assert_script_run "apt install -y emacs", 180;
    # Leave the root terminal and switch back to desktop.
    desktop_vt();
\end{verbatim}
\end{block}
\begin{block}{start the test (run emacs)}
\begin{verbatim}
    # Run emacs via Alt-F2
    wait_screen_change { send_key "alt-f2"; };
    wait_still_screen(stilltime=>5, similarity_level=>45);

    type_very_safely "emacs\n";
\end{verbatim}
\end{block}
\begin{block}{a little inherited paranoia}
\begin{verbatim}
    wait_still_screen(stilltime=>5, similarity_level=>44);
    if (check_screen "console_instead_of_GUI", 1) {
        die "failed to switch back to GUI";
    }
\end{verbatim}
\end{block}
\begin{block}{check things look OK}
\begin{verbatim}
    assert_screen "emacs_splashscreen";
    send_key "alt-x";
    type_safely "hanoi\n";
    assert_screen "emacs_hanoi_solved";
\end{verbatim}
\end{block}
\begin{block}{standard outro}
\begin{verbatim}
}

sub test_flags {
    return { fatal => 1 };
}

1;
\end{verbatim}
\end{block}
\end{frame}
\begin{frame}[label={sec:org46d5541},fragile]{Running the test}
 \begin{itemize}
\item clone one of the \emph{parent} test's jobs:
\begin{verbatim}
openqa-clone-job --skip-deps \
   https://openqa.debian.net/tests/57274 \
   POSTINSTALL=desktop_emacs
\end{verbatim}
\item use \emph{Developer Mode} to create new \emph{Needles}
\item or let the test fail, and add missing \emph{Needles} later

\url{http://localhost/tests/41816}
\item repeat required steps until it works
\url{http://localhost/tests/41812}
\end{itemize}
\end{frame}
\begin{frame}[label={sec:orgb078ef3}]{Contributing the test to run on openqa.debian.net}
\begin{itemize}
\item add your test into the \href{https://salsa.debian.org/qa/openqa/openqa-tests-debian/-/commit/79bfaa882a543e0a827c9aa5b560b5b1109ff366\#e22f359175909a38de98fa1cf5ac9e0ce83a9ad1}{templates.fif.json} file
\item push your changes to your salsa fork and open a Merge Request
\end{itemize}
\end{frame}
\begin{frame}[label={sec:orgcab5c79},fragile]{Questions and Answers}
 \begin{itemize}
\item \url{https://salsa.debian.org/qa/openqa/openqa-tests-debian/}
\item \url{https://openqa.debian.net/}
\item \url{https://open.qa/docs/\#writingtests}
\end{itemize}
\texttt{Email: phil@hands.com ─ IRC: fil}
\end{frame}
\end{document}
